Qwt User's Guide: QwtPolarPicker Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Signals | Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
QwtPolarPicker Class Reference

QwtPolarPicker provides selections on a plot canvas. More...

`#include <qwt_polar_picker.h>`

Inheritance diagram for QwtPolarPicker:

## Signals
void | selected (const QwtPointPolar &pos)
void | selected (const QVector< QwtPointPolar > &points)
void | appended (const QwtPointPolar &pos)
void | moved (const QwtPointPolar &pos)
Signals inherited from QwtPicker
void | activated (bool on)
void | selected (const QPolygon &polygon)
void | appended (const QPoint &pos)
void | moved (const QPoint &pos)
void | removed (const QPoint &pos)
void | changed (const QPolygon &selection)

## Public Member Functions
| QwtPolarPicker (QwtPolarCanvas *)
| Create a polar plot picker.
virtual | ~QwtPolarPicker ()
| Destructor.
| QwtPolarPicker (RubberBand rubberBand, DisplayMode trackerMode, QwtPolarCanvas *)
QwtPolarPlot * | plot ()
const QwtPolarPlot * | plot () const
QwtPolarCanvas * | canvas ()
const QwtPolarCanvas * | canvas () const
virtual QRect | pickRect () const
Public Member Functions inherited from QwtPicker
| QwtPicker (QWidget *parent)
| QwtPicker (RubberBand rubberBand, DisplayMode trackerMode, QWidget *)
virtual | ~QwtPicker ()
| Destructor.
void | setStateMachine (QwtPickerMachine *)
const QwtPickerMachine * | stateMachine () const
QwtPickerMachine * | stateMachine ()
void | setRubberBand (RubberBand)
RubberBand | rubberBand () const
void | setTrackerMode (DisplayMode)
| Set the display mode of the tracker.
DisplayMode | trackerMode () const
void | setResizeMode (ResizeMode)
| Set the resize mode.
ResizeMode | resizeMode () const
void | setRubberBandPen (const QPen &)
QPen | rubberBandPen () const
void | setTrackerPen (const QPen &)
QPen | trackerPen () const
void | setTrackerFont (const QFont &)
QFont | trackerFont () const
bool | isEnabled () const
bool | isActive () const
virtual bool | eventFilter (QObject *, QEvent *) override
| Event filter.
QWidget * | parentWidget ()
| Return the parent widget, where the selection happens.
const QWidget * | parentWidget () const
| Return the parent widget, where the selection happens.
virtual void | drawRubberBand (QPainter *) const
virtual void | drawTracker (QPainter *) const
virtual QRegion | trackerMask () const
virtual QRegion | rubberBandMask () const
QPoint | trackerPosition () const
virtual QRect | trackerRect (const QFont &) const
QPolygon | selection () const
Public Member Functions inherited from QwtEventPattern
| QwtEventPattern ()
virtual | ~QwtEventPattern ()
| Destructor.
void | initMousePattern (int numButtons)
void | initKeyPattern ()
void | setMousePattern (MousePatternCode, Qt::MouseButton button, Qt::KeyboardModifiers=Qt::NoModifier)
void | setKeyPattern (KeyPatternCode, int key, Qt::KeyboardModifiers modifiers=Qt::NoModifier)
void | setMousePattern (const QVector< MousePattern > &)
| Change the mouse event patterns.
void | setKeyPattern (const QVector< KeyPattern > &)
| Change the key event patterns.
const QVector< MousePattern > & | mousePattern () const
const QVector< KeyPattern > & | keyPattern () const
QVector< MousePattern > & | mousePattern ()
QVector< KeyPattern > & | keyPattern ()
bool | mouseMatch (MousePatternCode, const QMouseEvent *) const
| Compare a mouse event with an event pattern.
bool | keyMatch (KeyPatternCode, const QKeyEvent *) const
| Compare a key event with an event pattern.

## Protected Member Functions
QwtPointPolar | invTransform (const QPoint &) const
virtual QwtText | trackerText (const QPoint &) const override
virtual QwtText | trackerTextPolar (const QwtPointPolar &) const
| Translate a position into a position string.
virtual void | move (const QPoint &) override
virtual void | append (const QPoint &) override
virtual bool | end (bool ok=true) override
Protected Member Functions inherited from QwtPicker
virtual QPolygon | adjustedPoints (const QPolygon &) const
| Map the pickedPoints() into a selection()
virtual void | transition (const QEvent *)
virtual void | begin ()
virtual void | remove ()
virtual bool | accept (QPolygon &) const
| Validate and fix up the selection.
virtual void | reset ()
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetWheelEvent (QWheelEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | widgetEnterEvent (QEvent *)
virtual void | widgetLeaveEvent (QEvent *)
virtual void | stretchSelection (const QSize &oldSize, const QSize &newSize)
virtual void | updateDisplay ()
| Update the state of rubber band and tracker label.
const QwtWidgetOverlay * | rubberBandOverlay () const
const QwtWidgetOverlay * | trackerOverlay () const
const QPolygon & | pickedPoints () const
QRect | trackerRect (const QSize &) const
Protected Member Functions inherited from QwtEventPattern
virtual bool | mouseMatch (const MousePattern &, const QMouseEvent *) const
| Compare a mouse event with an event pattern.
virtual bool | keyMatch (const KeyPattern &, const QKeyEvent *) const
| Compare a key event with an event pattern.

## Private Member Functions
virtual QPainterPath | pickArea () const override

## Additional Inherited Members
Public Types inherited from QwtPicker
enum | RubberBand { NoRubberBand = 0 , HLineRubberBand , VLineRubberBand , CrossRubberBand , RectRubberBand , EllipseRubberBand , PolygonRubberBand , UserRubberBand = 100 }
enum | DisplayMode { AlwaysOff , AlwaysOn , ActiveOnly }
| Display mode. More...
enum | ResizeMode { Stretch , KeepSize }
Public Types inherited from QwtEventPattern
enum | MousePatternCode { MouseSelect1 , MouseSelect2 , MouseSelect3 , MouseSelect4 , MouseSelect5 , MouseSelect6 , MousePatternCount }
| Symbolic mouse input codes. More...
enum | KeyPatternCode { KeySelect1 , KeySelect2 , KeyAbort , KeyLeft , KeyRight , KeyUp , KeyDown , KeyRedo , KeyUndo , KeyHome , KeyPatternCount }
| Symbolic keyboard input codes. More...
Public Slots inherited from QwtPicker
void | setEnabled (bool)
| En/disable the picker.

## Detailed Description

QwtPolarPicker provides selections on a plot canvas.

QwtPolarPicker is a QwtPicker tailored for selections on a polar plot canvas.

Definition at line 28 of file qwt_polar_picker.h.

## Constructor & Destructor Documentation

## ◆ QwtPolarPicker() [1/2]

QwtPolarPicker::QwtPolarPicker | ( | QwtPolarCanvas * | canvas | ) |
| explicit

Create a polar plot picker.

Parameters

  canvas | Plot canvas to observe, also the parent object

Definition at line 25 of file qwt_polar_picker.cpp.

## ◆ ~QwtPolarPicker()

QwtPolarPicker::~QwtPolarPicker | ( |  | ) |
| virtual

Destructor.

Definition at line 51 of file qwt_polar_picker.cpp.

## ◆ QwtPolarPicker() [2/2]

QwtPolarPicker::QwtPolarPicker | ( | RubberBand | rubberBand,
|  | DisplayMode | trackerMode,
|  | QwtPolarCanvas * | canvas )
| explicit

Create a plot picker

Parameters

  rubberBand | Rubberband style
  trackerMode | Tracker mode
  canvas | Plot canvas to observe, also the parent object

See also
  QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode
  QwtPolarPlot::autoReplot(), QwtPolarPlot::replot(), scaleRect()

Definition at line 43 of file qwt_polar_picker.cpp.

## Member Function Documentation

## ◆ append()

void QwtPolarPicker::append | ( | const QPoint & | pos | ) |
| overrideprotectedvirtual

Append a point to the selection and update rubberband and tracker.

Parameters

  pos | Additional point

See also
  isActive, begin(), end(), move(), appended()

Note
  The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 128 of file qwt_polar_picker.cpp.

## ◆ appended

void QwtPolarPicker::appended | ( | const QwtPointPolar & | pos | ) |
| signal

A signal emitted when a point has been appended to the selection

Parameters

  pos | Position of the appended point.

See also
  append(). moved()

## ◆ canvas() [1/2]

QwtPolarCanvas * QwtPolarPicker::canvas | ( |  | ) |

Returns
  Observed plot canvas

Definition at line 56 of file qwt_polar_picker.cpp.

## ◆ canvas() [2/2]

const QwtPolarCanvas * QwtPolarPicker::canvas | ( |  | ) | const

Returns
  Observed plot canvas

Definition at line 62 of file qwt_polar_picker.cpp.

## ◆ end()

bool QwtPolarPicker::end | ( | bool | ok = true | ) |
| overrideprotectedvirtual

Close a selection setting the state to inactive.

Parameters

  ok | If true, complete the selection and emit selected signals otherwise discard the selection.

Returns
  true if the selection is accepted, false otherwise

Reimplemented from QwtPicker.

Definition at line 157 of file qwt_polar_picker.cpp.

## ◆ invTransform()

QwtPointPolar QwtPolarPicker::invTransform | ( | const QPoint & | pos | ) | const
| protected

Translate a point from widget into plot coordinates

Parameters

  pos | Point in widget coordinates of the plot canvas

Returns
  Point in plot coordinates

See also
  transform(), canvas()

Definition at line 208 of file qwt_polar_picker.cpp.

## ◆ move()

void QwtPolarPicker::move | ( | const QPoint & | pos | ) |
| overrideprotectedvirtual

Move the last point of the selection

Parameters

  pos | New position

See also
  isActive, begin(), end(), append()

Note
  The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 143 of file qwt_polar_picker.cpp.

## ◆ moved

void QwtPolarPicker::moved | ( | const QwtPointPolar & | pos | ) |
| signal

A signal emitted whenever the last appended point of the selection has been moved.

Parameters

  pos | Position of the moved last point of the selection.

See also
  move(), appended()

## ◆ pickArea()

QPainterPath QwtPolarPicker::pickArea | ( |  | ) | const
| overrideprivatevirtual

Find the area of the observed widget, where selection might happen.

Returns
  parentWidget()->contentsRect()

Reimplemented from QwtPicker.

Definition at line 229 of file qwt_polar_picker.cpp.

## ◆ pickRect()

QRect QwtPolarPicker::pickRect | ( |  | ) | const
| virtual

Returns
  Bounding rectangle of the region, where picking is supported.

Definition at line 221 of file qwt_polar_picker.cpp.

## ◆ plot() [1/2]

QwtPolarPlot * QwtPolarPicker::plot | ( |  | ) |

Returns
  Plot widget, containing the observed plot canvas

Definition at line 68 of file qwt_polar_picker.cpp.

## ◆ plot() [2/2]

const QwtPolarPlot * QwtPolarPicker::plot | ( |  | ) | const

Returns
  Plot widget, containing the observed plot canvas

Definition at line 78 of file qwt_polar_picker.cpp.

## ◆ selected [1/2]

void QwtPolarPicker::selected | ( | const QVector< QwtPointPolar > & | points | ) |
| signal

A signal emitting the selected points, at the end of a selection.

Parameters

  points | Selected points

## ◆ selected [2/2]

void QwtPolarPicker::selected | ( | const QwtPointPolar & | pos | ) |
| signal

A signal emitted in case of selectionFlags() & PointSelection.

Parameters

  pos | Selected point

## ◆ trackerText()

QwtText QwtPolarPicker::trackerText | ( | const QPoint & | pos | ) | const
| overrideprotectedvirtual

Translate a pixel position into a position string

Parameters

  pos | Position in pixel coordinates

Returns
  Position string

Reimplemented from QwtPicker.

Definition at line 93 of file qwt_polar_picker.cpp.

## ◆ trackerTextPolar()

QwtText QwtPolarPicker::trackerTextPolar | ( | const QwtPointPolar & | pos | ) | const
| protectedvirtual

Translate a position into a position string.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the double to string conversion is "%.4f".

Parameters

  pos | Position

Returns
  Position string

Definition at line 111 of file qwt_polar_picker.cpp.